#line 1 "C:/_MikroC/_MesProjets_MikroC/_18F87J50_GPS/Survivor_18F87J50_Test_NMEA_lib_GPS_UART2_Display_UART1_161022.c"
#line 43 "C:/_MikroC/_MesProjets_MikroC/_18F87J50_GPS/Survivor_18F87J50_Test_NMEA_lib_GPS_UART2_Display_UART1_161022.c"
sbit LD1 at LATD4_bit;
sbit LD2 at LATE4_bit;
sbit LD1_Direction at TRISD4_bit;
sbit LD2_Direction at TRISE4_bit;

sbit RE6_FAULT at RE6_bit;
sbit RE5_SENSEL at LATE5_bit;
sbit RJ5_Stat at RJ5_bit;
sbit RF6_VSENSE at RF6_bit;


sbit Led_Rouge at LATD4_bit;
sbit Led_Rouge_Directiont at TRISD4_bit;

sbit BP1 at RD7_bit;
sbit BP2 at RH3_bit;
sbit BP1_Direction at TRISD7_bit;
sbit BP2_Direction at TRISH3_bit;



sbit NMEA_IntFlag at RC2IF_bit;

char buffer[128];
char nmea[128];
char rcvd = 0;

void CRLF1()
{
UART1_Write( 13 );
UART1_Write( 10 );
}

 unsigned char strcmp_P(char *ram_str, const char *rom_str){
 char diff,c;
 while((c = *rom_str++)){
 diff = *ram_str++ - c;
 if(diff)
 return diff;
 }
 return 0;
}

 void UART1_Write_CText(const char *txt1)
 {
 while (*txt1)
 UART1_Write(*txt1++);
}


void interrupt() {
 NMEA_IntHandler();
}


void NMEA_DataReceived() {
 rcvd = 1;
}

void DisplayData(char * caption, char * txt) {
 UART1_Write_Text(caption);
 UART1_Write(9);
 UART1_Write_Text(txt);
 CRLF1();
#line 112 "C:/_MikroC/_MesProjets_MikroC/_18F87J50_GPS/Survivor_18F87J50_Test_NMEA_lib_GPS_UART2_Display_UART1_161022.c"
 Delay_ms(1000);
}



 void Hardware_Init(void)
 {

 ANCON0=0xFD ;
 ANCON1=0xFF;
 TRISA=0xFF;
 TRISA2_bit=0;
 TRISB=0xFF;
 TRISD=0xFF;
 TRISC=0xFF;
 TRISG=0xFF;

 TRISD6_bit=0;

 BP1_Direction = 1;
 BP2_Direction = 1;
 LD1_Direction = 0;
 LD2_Direction = 0;
 LD1 = 0;
 LD2 = 0;

 }

void main() {
 char gps_data[20];
 char tmp[2];



 Hardware_Init() ;





 UART1_Init(19200);
 UART2_Init( 19200 );

 NMEA_Init(&UART2_Read, buffer, sizeof(buffer));

 RC2IE_bit = 1;
 PEIE_bit = 1;
 GIE_bit = 1;

 UART1_Write( 12 );
 Delay_ms(500);
 UART1_Write_CText(" \r\n Hardware: \r\n Survivor (bad Clicker2) 18F87J50 + GPS UBox 7N\r\n");
 UART1_Write_CText(" Directory :" "C:\_MikroC\_MesProjets_MikroC\_18F87J50_GPS" "\r\n");
 UART1_Write_CText(" Projet :" "Survivor_GPS_7N_Test_NMEA_Library.mcppi" "\r\n");
 UART1_Write_CText(" Source MikroC " "Survivor_18F87J50_Test_NMEA_lib_GPS_UART2_Display_UART1" "_" "161022" ".c\r\n");
 UART1_Write_CText(" FOSC=Q=8Mhz  x PLL => 48Mhz  Alim : 3,3V \r\n");
 UART1_Write_CText(" Alimentation : 3,3V externe \r\n");
 UART1_Write_CText(" \r\n");
 UART1_Write_Text("Test NMEA 18F library with SURVIVOR PIC18F87J50\r\n");
 UART1_Write_Text("GPS Ublox 7N sur RG1 & RG2 UART2 MikroBus#1 at 19200 bds\r\n");
 UART1_Write_Text("Display via UART1 RC7 RC6 MikroBus#2 on TeraTerm terminal 19200 bds\r\n");
 CRLF1();
 while(1) {
 if (rcvd) {
 strcpy(nmea, buffer);


 if (NMEA_IsValid(nmea) && strstr(nmea, "$GPGGA")) {

 NMEA_Split(gps_data, nmea, ',', 1);
 DisplayData("UTC Time:", gps_data);


 NMEA_Split(gps_data, nmea, ',', 2);
 NMEA_Split(tmp, nmea, ',', 3);
 strcat(gps_data, tmp);
 DisplayData("Latitude:", gps_data);


 NMEA_Split(gps_data, nmea, ',', 4);
 NMEA_Split(tmp, nmea, ',', 5);
 strcat(gps_data, tmp);
 DisplayData("Longitude:", gps_data);


 NMEA_Split(gps_data, nmea, ',', 6);
 DisplayData("Fix quality:", gps_data);


 NMEA_Split(gps_data, nmea, ',', 7);
 DisplayData("Num of sats:", gps_data);

 CRLF1();
 }
 rcvd = 0;
 }
 }
}
